# Installation of CPU Energy Meter and BenchExec from Debian packages

Installing the provided Debian packages has been tested on Ubuntu 18.04 64-bit,
but should also work on other recent Ubuntu and Debian versions
(if it is a 64-bit version and if it uses systemd).

## Installation of CPU Energy Meter

CPU Energy Meter requires the package "libcap2" to be installed,
it is recommended to install it with `sudo apt-get install libcap2`.
For completeness of the artifact, the Ubuntu 18.04 version of this package
is also provided in this directory and can be installed with
`sudo dpkg -i libcap2*.deb`.

Afterwards, the only necessary step is to install the Debian package in this directory:
`sudo dpkg -i cpu-energy-meter*.deb`


## Installation of BenchExec

BenchExec requires Python 3.4 or newer,
which needs to be installed and is not contained in this artifact.
Furthermore, BenchExec requires the packages
`python3-pkg-resources`, `python3-tempita`, and `python3-yaml` to be installed.
It is recommended to install them with
`sudo apt-get install python3-pkg-resources python3-tempita python3-yaml`.
For completeness of the artifact, the Ubuntu 18.04 version of these packages
are also provided in this directory and can be installed with
`sudo dpkg -i python3-*.deb`.

1. Install the Debian package in this directory: `sudo dpkg -i benchexec*.deb`

2. Add your own user to the group "benchexec": `sudo adduser $(whoami) benchexec`

3. Please reboot to activate the kernel and systemd settings for BenchExec.

4. If your machine has swap, BenchExec needs a specific kernel setting.
   You can either enable `swapaccount=1` as described in
   [the BenchExec installation instructions](../source/INSTALL-BenchExec.md),
   or temporarily turn of swap while benchmarking with `sudo swapoff -a`.

On older systems or systems with different distributions than Ubuntu,
some kernel features might be missing.
If you have problems running BenchExec,
please check the requirements in
[the manual BenchExec installation instructions](../source/INSTALL-BenchExec.md).
