# Installation of CPU Energy Meter and BenchExec from Source

## Installation of CPU Energy Meter

1. CPU Energy Meter requires the library "libcap" from
   https://sites.google.com/site/fullycapable/
   It is recommended to install the library from your distribution packages
   (both the library itself and the development headers),
   but you can also install it manually from the tar archive provided in this directory:
   `tar xf libcap-2.25.tar.xz; cd libcap-2.25; make; sudo make install; cd ..`.

2. Configure your system such that it loads the kernel module "msr"
   and gives access to the group "msr":

  ```
  sudo groupadd --system msr
  echo 'SUBSYSTEM=="msr", GROUP="msr", MODE="0640"' | sudo tee /etc/udev/rules.d/59-msr.rules
  echo 'msr' | sudo tee -a /etc/modules
  sudo udevadm control --reload-rules
  sudo udevadm trigger
  sudo modprobe msr
  ```

3. Install CPU Energy Meter itself with

  ```
  tar xf cpu-energy-meter-1.2.tar.gz
  cd cpu-energy-meter-1.2
  make
  sudo make install
  sudo chgrp msr /usr/local/bin/cpu-energy-meter
  sudo chmod 2711 /usr/local/bin/cpu-energy-meter
  sudo setcap cap_sys_rawio=ep /usr/local/bin/cpu-energy-meter
  ```
  If compilation fails because of a missing `sys/capability.h` header,
  please make sure you have the development headers of `libcap` installed
  and available in the include path of your compiler.

## Installation of BenchExec

BenchExec requires Python 3 and pip3,
which need to be installed from your distribution packages
and are not contained in this artifact.
For the installation of BenchExec,
we refer to an (adjusted) copy of BenchExec's installation instructions
in INSTALL-BenchExec.md.
